defmodule DecentralisedBookIndex.Sync.AuthorSync do
  alias DecentralisedBookIndex.Metadata.Author

  def create_update(author_attrs) do
    case DecentralisedBookIndex.Metadata.get_author_by_id(author_attrs.id) do
      {:ok, author} ->
        author_attrs =
          author_attrs
          |> Map.delete(:id)
          |> Map.delete(:author_alias_registry_id)

        author
        |> Ash.Changeset.for_update(:update, author_attrs)
        |> Ash.update!()

        :ok
      {:error, %Ash.Error.Query.NotFound{}} ->
        DecentralisedBookIndex.Metadata.Author
        |> Ash.Changeset.for_create(:sync, author_attrs)
        |> Ash.create!()

        :ok
    end
  end
end
